



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python（31）——【sys模块】【json模块 &amp; pickle模块】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python（31）——【sys模块】【json模块 &amp; pickle模块】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 10:42:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>一、sys模块</h1>
<div>
<pre class="prettyprint linenums">import sys<br />
sys.argv    #命令行参数List，第一个元素是程序本身路径<br />
sys.exit()    #退出程序，正常退出时exit(0)<br />
sys.version    #获取python解释程序的版本信息<br />
sys.maxint    #最大的int值<br />
sys.path    #返回模块的搜索路径，初始化时使用PYTHONPATH环境变量的值<br />
sys.platform    #返回操作系统平台的名称</pre>
</div>
<h2>1. sys.argv （非常重要）</h2>
<h3>应用：我们之前需要做判断是在程序执行过程中进行逻辑判断和选择。如果需求是在程序还没有执行时，对用户操作进行判断，即直接对程序进行操作和选择</h3>
<p>sys_module.py内容如下：</p>
<div>
<pre class="prettyprint linenums">import sys<br />
print(sys.argv)</pre>
</div>
<p>在终端来执行sys_module.py，命令行后可添加参数（第一个参数为用户要执行的操作，第二个参数为路径），执行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1517322/201903/1517322-20190311100156975-1973109179.png" /></p>
<p>sys.arge提供了一个在命令行后面添加参数的机制，通过对相关参数进行解析，可对用户操作在程序执行前进行判断。</p>
<p>sys_module.py内容如下：</p>
<div>
<pre class="prettyprint linenums">import sys<br />
print(sys.argv)<br />
command = sys.argv[1]<br />
path = sys.argv[2]<br />
if command == 'post':<br />
    print('post')<br />
elif command == 'get':<br />
    print('get')</pre>
</div>
<p>#终端执行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1517322/201903/1517322-20190311100331134-316887684.png" /></p>
<h2>2. 关于环境变量的问题</h2>
<p>关于环境变量的修改</p>
<p>#临时修改环境变量方法</p>
<div>
<pre class="prettyprint linenums">import sys<br />
sys.path.append()</pre>
</div>
<p>#永久修改环境变量方法（如下图所示）</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1517322/201903/1517322-20190311100407191-2058284505.png" /></p>
<h3>关于from...import...的补充</h3>
<p>cal.py的内容如下：</p>
<div>
<pre class="prettyprint linenums">A = 5.20<br />
if  __name__=='__main__':<br />
    def add_cal(x,y):<br />
        return x + y + A</pre>
</div>
<p>　　</p>
<p>TEST.py的内容如下：</p>
<div>
<pre class="prettyprint linenums">from cal import A<br />
if __name__=='__main__'：<br />
    print(A)
</pre>
</div>
<p>　　</p>
<p>TEST.py和cal.py的关系如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1517322/201903/1517322-20190311101804475-1385947109.png" /></p>
<p>执行TEST.py结果如下：5.2</p>
<p>TEST.py和cal.py的关系如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1517322/201903/1517322-20190311101817176-1958380760.png" /></p>
<p>执行TEST.py结果报错，因此需要在TEST.py中人为的添加绝对路径</p>
<div>
<pre class="prettyprint linenums">__file__ == 文件名（但是在pycharm会自动加入绝对路径）</pre>
</div>
<p>思路一：利用sys.path.append()直接进行绝对路径的添加</p>
<div>
<pre class="prettyprint linenums">import sys<br />
sys.path.append('D:/Users/XIAOHuoguo/PycharmProjects/TF_Learning/day4')<br />
from cal import A<br />
if __name__=='__main__':<br />
    print(A)</pre>
</div>
<p>#结果分析：虽然程序可以正常执行，但是程序可移植性较差</p>
<p>思路二：利用os.path.dirname(path)    #返回path的目录，其实就是os.path.split(path)的第一个元素</p>
<div>
<pre class="prettyprint linenums">import sys<br />
import os<br />
BASE_DIR = os.path.dirname(os.path.dirname(__file__))<br />
sys.path.append(BASE_DIR)<br />
from cal import A<br />
if __name__=='__main__':<br />
    print(A)</pre>
</div>
<p>#结果分析：虽然程序可以正常执行，但是__file__==文件名，只是pycharm自动添加绝对路径，因此该程序无法再终端执行，会报错</p>
<p>思路三：通过sys.path.abspath()来获取绝对路径</p>
<div>
<pre class="prettyprint linenums">import sys<br />
import os<br />
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))<br />
sys.path.append(BASE_DIR)<br />
from cal import A<br />
if __name__ == '__main__':<br />
    print(A)</pre>
</div>
<p>#结果分析：程序可以再pycharm和终端正常执行，且可移植性能较好</p>
<h2>3. 进度条的实现</h2>
<div>
<pre class="prettyprint linenums">import sys<br />
import time<br />
for i in range(50):<br />
    sys.stdout.write('*')     #向屏幕打印操作，print的内部就是sys.stdout.write()操作<br />
    time.sleep(0.1)<br />
    sys.stdout.flush()        #动态刷新（不添加该语句，则直接全部打印）</pre>
</div>
<h1>二、 json模块 &amp; pickle模块</h1>
<h2>1. json</h2>
<ul><li>如果我们要在不同编程语言之间传递对象，就必须把对象序列化为标准格式，比如XML，但更好的方法是序列化为JSON，</li>
<li>因为JSON表示出来就是一个字符串，可以被所有语言读取，也方便地存储到磁盘或者通过网络传输</li>
<li>JSON不仅是标准格式，并且比XML更快，而且可以直接在web页面中读取，非常方便</li></ul>
<h2>2. JSON表示的对象就是标准的JavaScript语言的对象，JSON和Python内置的数据类型对应如下：</h2>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1517322/201903/1517322-20190311102040146-695683998.png" /></p>
<h2>3. 序列化</h2>
<ul><li>我们把对象（变量）从内存中变成可存储或传输的过程称之为序列化。在Python中叫pickling，在其他语言中被称之为serialization，marshalling等，都是一个意思</li>
<li>序列化之后，就可以把序列化后的内容写入磁盘，或者通过网络传输到别的机器上</li>
<li>反过来，把变量内容从序列化的对象重新读到内存里称之为反序列化，即unpickling。</li></ul>
<p>回顾：通过eval()实现数据交换</p>
<div>
<pre class="prettyprint linenums">#对文件进行写操作（只能写入字符串类型）

dic = '{"name": "xhg"}'<br />
f = open('hello', 'w')<br />
f.write(dic)<br />
f.close()</pre>
</div>
<div>
<pre class="prettyprint linenums">#对文件进行读操作（读初字典name键对应的值xhg）

f_read = open('hello', 'r')<br />
data = f_read.read()<br />
print(type(data))<br />
data = eval(data)<br />
print(data["name"])<br />
f_read.close()

#执行结果：<br />
&lt;class 'str'&gt;<br />
xhg<br />
#结果分析：对文件进行读操作，读出的数据类型为字符串，通过eval()对数据处理，将字符串转换为字典，再进行键值对处理。</pre>
</div>
<h3>上述过程可以通过json模块和pickle模块来进行实现</h3>
<div>
<pre class="prettyprint linenums">#利用json进行写操作（序列化）<br />
import json<br />
dic = {'name': 'xhg'}<br />
data = json.dumps(dic)<br />
print(data)<br />
print(type(data))<br />
#执行结果：<br />
{"name": "xhg"}<br />
&lt;class 'str'&gt;<br />
#结果分析：data是json字符串，是所有语言都支持的规范 .json字符串最明显的特征是：各种引号变为双引号。json.dumps()之后，所有数据类型均转化为json字符串（加载成字符串）<br />
#json字符串最明显的特征是：各种引号变为双引号。<br />
dic = {'name': 'alex'} ----&gt; {"name": "alex"}<br />
i = 8 ----&gt; ""<br />
s = 'hello' ----&gt; "hello"<br />
l = [11, 22] ----&gt; "[11, 22]"</pre>
</div>
<div>
<pre class="prettyprint linenums">#利用json模块对文件进行写操作（序列化）<br />
import json<br />
dic = {'name': 'xxx'}<br />
print(type(dic))    #&lt;class 'dict'&gt;<br />
data = json.dumps(dic)<br />
print(type(data))    #&lt;class 'str'&gt;<br />
f = open('hello','w')<br />
f.write(data)<br />
f.close()</pre>
</div>
<div>
<pre class="prettyprint linenums">#利用json模块对文件进行读操作（读初字典name键对应的值xhg）（反序列化）<br />
import json<br />
f_read = open('hello', 'r')<br />
data = json.loads(f_read.read())<br />
print(type(data))<br />
print(data)<br />
print(data['name'])<br />
f_read.close()

#执行结果：<br />
&lt;class 'dict'&gt;<br />
{'name': 'xxx'}<br />
xxx<br />
#结果分析：json.loads()读出来的数据是最初的数据类型</pre>
</div>
<h2>4. dump &amp; dumps load &amp; loads 区别</h2>
<div>
<pre class="prettyprint linenums">#dumps()<br />
import json<br />
dic = {'name': 'xhg'}<br />
f = open('hello','w')<br />
data = json.dumps(dic)<br />
f.write(data)<br />
f.close()

#dump()<br />
import json<br />
dic = {'name': 'xxx'}<br />
f = open('hello','w')<br />
json.dump(dic, f)<br />
f.close()</pre>
</div>
<p><strong>#结论：</strong><br /><strong>#dump() &lt;----&gt; json.dumps();f.write()</strong><br /><strong>#dump()相当于进行了两步操作，load &amp; loads区别同dump &amp; dumps区别，建议使用dumps()和loads()</strong></p>
<p><strong>#提示</strong>：并不是只有dumps()之后可以才可以使用loads()，只要你写入的字符串符合json字符串的规定（双引号），就可以使用loads()</p>
<h2>5.pickle模块</h2>
<ul><li>pickle模块也是用来做数据交换的，与json模块的区别如下：</li>
<li>pickle结果是字节，json结果是字符串</li>
<li>json写进去是可读的（字符串），pickle写进去是不可读的（字节）</li>
<li>pickle支持的数据类型更多</li></ul>
<div>
<pre class="prettyprint linenums">#利用pickle模块对文件进行写操作（序列化）<br />
import pickle<br />
dic = {'name': 'alex', 'age': 18, 'sex': 'female'}<br />
print(type(dic))    #&lt;class 'dict'&gt;<br />
j = pickle.dumps(dic)<br />
print(type(j))  #&lt;class 'bytes'&gt;<br />
f = open('test_pickle', 'wb')   #注意w是写入str，wb是写入bytes，j是&lsquo;bytes&rsquo;<br />
f.write(j)<br />
f.close()

#利用pickle模块对文件进行读操作（反序列化）<br />
import pickle<br />
f = open('test_pickle', 'rb')<br />
data = pickle.loads(f.read())<br />
print(data['age'])</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnyvn28.html">安装mongodb  远程服务器报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd3l4x8.html">18&period;1---不用加号的加法（CC150）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxp5le9.html">Matlab 用fread、fwrite实现大文件读写</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdzdwe8.html">SQL 2008 数据库只读 修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnwmgz8.html">Poj&lpar;2679&rpar;&comma;SPFA&comma;邻接表&lpar;主流写法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn151yg8.html">销售订单行上行号LINE&lowbar;SHIPMENT&lowbar;OPTION&lowbar;NUMBER</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12rnj9.html">homework-05 GoldNumberServer</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvnrg1q.html">Discuz&excl;NT中集成Memcached分布式缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn335rq.html">定制化Azure站点Java运行环境&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkn62e8.html">javascript实现图片无缝滚动（scrollLeft的使用方法介绍）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mdng38.html">oracle中的常用函数1-------decode方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpgz2xq.html">Python 进程与线程小随笔</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zozxn9.html">Java单元测试初体验&lpar;JUnit4&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdro2d9.html">Dijkstra【迪杰斯特拉算法】</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rp62o9.html">bugku的一道图片隐写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyykwejq.html">ActiveMQ的安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd1zmj9.html">Linux学习（2）－ 正则表达式基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9537vne8.html">金融科技行业 SDL（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kedpxq.html">LeetCode&colon; Restore IP Addresses  解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em62wk9.html">在loadrunner中使用winsocket协议编写脚步三部曲</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv23zno9.html">list 删除元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv230jj9.html">20175126《Java程序设计》第一周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g7jomq.html">TZOJ 4602 高桥和低桥&lpar;二分或树状数组&plus;二分&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy054gq.html">73&period; Set Matrix Zeroes 把矩阵同一行列的元素都改成0</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zye45v9.html">Python项目--Scrapy框架&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdz65v9.html">tomact的安装配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllpw2xq.html">python程序编写简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wg3e0q.html">用nodejs搭建类似于C&plus;&plus;的服务器后台&period;类似网易pomelo</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv4g3k8.html">CSS三种插入样式表格式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv4kog8.html">python基本数据类型之字符串（五）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
